<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- snippetprovider.cpp -->
  <title>Snippets for Editors | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Snippets for Editors</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar"><div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Snippets for Editors</h1>
<span class="subtitle"></span>
<!-- $$$Snippets-description -->
<div class="descr"> <a name="details"></a>
<p>Snippets typically consist of chunks of code in a programming language (although they can also be plain text) which you would like to avoid re-typing every time. They are triggered in the same way as the completions (see <a href="codeassist.html">Providing Code Assist</a>).</p>
<p>In order to create a new group of snippets two steps are necessary:</p>
<ul>
<li>Register the group with TextEditor::SnippetProvider::registerGroup</li>
<li>Create an XML configuration file and place it in the /share/qtcreator/snippets directory. As an example of the file format please take a look at the already available ones. The meaning and consistency rules of the fields are described below:<ul>
<li>group - This is the group in which the snippet belongs in the user interface. It must match TextEditor::SnippetProvider::groupId().</li>
<li>id - A unique string that identifies this snippet among all others available. The recommended practice is to prefix it with the group so it is easier to have such control on a file level.</li>
<li>trigger - The sequence of characters to be compared by the completion engine in order to display this snippet as a code assist proposal.</li>
<li>complement - Additional information that is displayed in the code assist proposal so it is possible to disambiguate similar snippets that have the same trigger.</li>
</ul>
</li>
</ul>
<p>All XML configuration files found in the directory mentioned above are parsed by Qt Creator. However, only the ones which are associated with known groups (specified by a provider) are taken into consideration.</p>
</div>
<!-- @@@Snippets -->
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
